//Name: Joseph Tarango
//Developed for Research Project

#include <iostream>//Standard I/O
#include <sstream> //integer to string conversion
#include <fstream>//File output
#include <math.h>//Used for pow function & log2

using namespace std;

//Converts int to string
string itos(int i)
{
  stringstream s;
  s << i;
  return s.str();
}

string binarytostring(int K, int bits)
{
  string fBin = "", addZero = "";
  int a,b = K, binSize = 0;
  //string itos(int);
  
  while(b > 0)
    {
      a = b % 2;
      b = b / 2;
      
      fBin += itos(a);
    }
  
  binSize = bits - fBin.length();
  
  //add trailing zeros
  for(int i=0;i<binSize;i++)
    { addZero += "0"; }
  
  if((int)fBin.length() < bits)
    { fBin+=addZero; }
  
  //reverse the string of binary
  int x = fBin.length(); //takes length of string
  //For loop arranging the string
  for(int y = x; y >= (x/2)+1; y--) {
    //swaps letters
    swap(fBin[x-y],fBin[y-1]);
  }
  
  return fBin;
}

string binarycountofones(string binaryvalue, int binarydigits)
{
  int count = 0;
  for(int i = 0; i < (int)binaryvalue.size(); i++) {
    if(binaryvalue[i] == '1') 
      { count++; }
  }
  return binarytostring(count, (int)log2(binarydigits)+1);
}

void gen_file(int binarydigits)
{
  ofstream outputfile;

  //int to string conversion
  string tmp = itos(binarydigits);  

  string filename = "numones_for" + tmp;
  string entityname = filename;
  filename = filename + ".vhd";
  outputfile.open(filename.c_str());
  
  outputfile << "library IEEE;\n";
  outputfile << "use IEEE.STD_LOGIC_1164.ALL;\n";
  outputfile << "use IEEE.STD_LOGIC_ARITH.ALL;\n";
  outputfile << "use IEEE.STD_LOGIC_UNSIGNED.ALL;\n";
  outputfile << "entity ";
  outputfile << entityname;
  outputfile << " is\n";
  outputfile << "     Port ( input : in STD_LOGIC_VECTOR( 0 to ";
  outputfile << binarydigits-1;
  outputfile << " );\n";
  outputfile << "            output : out STD_LOGIC_VECTOR( 0 to ";
  outputfile << (int)log2(binarydigits);
  outputfile << " ));\n";
  outputfile << "end ";
  outputfile << entityname;
  outputfile << ";\n";
  outputfile << "architecture Behavioral of ";
  outputfile << entityname;
  outputfile << " is\n";
  outputfile << "begin\n";
  outputfile << "with input select\n";
  outputfile << "output <= ";
  outputfile << "\"";
  tmp = binarytostring(0, binarydigits);
  outputfile << binarycountofones(tmp, binarydigits);
  outputfile << "\"";
  outputfile << " when ";
  outputfile << "\"";
  outputfile << tmp;
  outputfile << "\"";
  outputfile << ",\n";
  string binary_str, numones_str;
  for(int i = 1; i < pow(2, binarydigits); i = i + 1) {
    binary_str = binarytostring(i, binarydigits);
    numones_str = binarycountofones(binary_str, binarydigits);
    outputfile << "          ";
    outputfile << "\"";
    outputfile << numones_str;
    outputfile << "\"";
    outputfile << " when ";
    outputfile << "\"";
    outputfile << binary_str;
    outputfile << "\"";
    outputfile << ",\n";
    cout << i << " ";
  }
  outputfile << "          ";
  outputfile << "\"";
  outputfile << binarytostring(0, (int)log2(binarydigits)+1);
  outputfile << "\"";
  outputfile << " when others;\n";
  outputfile << "end Behavioral;\n";
  outputfile.close();

  cout << "Filename is: " << filename << endl;

  return;
}

int main()
{
  int binarydigits = 0;

  cout << "Welcome to binary 1s count." << endl;
  cout << "Program will generate a file to count";
  cout << " the number of ones in a binary integer";
  cout << " in the range you enter." << endl;
  cout << "Enter number of Binary Digits: ";
  cin >> binarydigits;
  cout << "Generating VHDL code..." << endl;
  gen_file(binarydigits);
  cout << "Done generating VHDL code...";

  return 0;
}
